/* Accounting Server (C) Copyright by Robert Stephens 1996

Bugs
------------------------------------------
Fixed all the buggers... till the next

*/
Parse Arg Nodes
Version = '0.10'
If Nodes = '' Then Do
   Say 'PPP Accounting Server v' || Version
   Say 'Error: You must specify the number of nodes to startup. Eg'
   Say 'Server.Cmd 4'
   Exit
End
Say 'Starting up ' || Nodes || ' Nodes ...'

/*-| Begin Configuration |----------------------------------------------------*/
SleepTime = '10'   /* When Users are online, how often will I update the screen */
MinimumTimeForAccounting = '30'
AccountingTime = '10800'  /* Time at start of month to run accounting Secs since Midnight = 3am */
CostFile = 'D:\Adept\PPP\Hourly.Rates'
LogFile = 'D:\Adept\PPP\Accounting.Log'
AccountingDirectory = 'D:\Adept\PPP\Accounts\'
AccountHeader = 'D:\Adept\PPP\Data\AccountHeader.Txt'
AccountFooter = 'D:\Adept\PPP\Data\AccountFooter.Txt'
BillOutDirectory = 'D:\Adept\PPP\Out\'
Pipe = '\pipe\adeptppp'
/*--------------------------| End Configuration |-----------------------------*/

ScrollLine = Nodes + 4
Today = Date('D')
Call RxFuncAdd 'SysCurState', 'RexxUtil', 'SysCurState'
Call SysCurState 'OFF'
Call ReadCost

InternetUsers = 0
MoneyEarnt = 0
RunningNodes = ''

Call SetupScreen
Call RecentEvents 'Begin PPP Internet Accounting Server v' || Version
Call RecentEvents "Press 'Q' to Terminate"
Call RecentEvents 'Setting up \pipe\adeptppp'

Call SetupPIPE
AccountingTime = ((Today) * 86400) + AccountingTime
TheTime = ((Today - 1) * 86400) + Time('S')
TimeControl = TheTime + SleepTime
TimeControl2 = TheTime + 60
Call RecentEvents 'Waiting for client or event'
LastAck = TheTime
Do Forever
   Key = InKey('N')
   If Key = 'q' Then Do
      If RunningNodes \= '' Then Do
         Call RecentEvents 'Warning! There are active processes. Quit [y/N]:'
         Temp = InKey()
         If Temp = 'y' Then Do
            Call RecentEvents 'Exit requested from Keyboard (Processes were running)'
            Leave
         End
         Else Call RecentEvents 'Resumed processing'
      End
      Else Do
         Call RecentEvents 'Exit requested from Keyboard'
         Leave
      End
   End
   If NmPipe_Connect(Pipe) = 0 Then Do
      PipeData = NmPipe_Read(Pipe,48)
      Call Delay '0.1'
      Call NmPipe_Close Pipe
      Call SetupPIPE
      Control = SubStr(PipeData,3,1)          /* 1=Login, 2=LogOut, 3=Ack */
      Node = Strip(Left(PipeData,2))
      Select
       When Control = 1 Then Do                                  /* Login */
          RunningNodes = RunningNodes || Node || ' '
          Call UpdateNode SubStr(PipeData,7,43) || ' ' || Left(Time(),5)
          Cost.Node = 0
          Detail.Node = ''
          DateIn.Node = Date('E')
          UserName.Node = Strip(SubStr(PipeData,7,21))
          LoginRealTime.Node = Time()
          TimeIn.Node = ((Today - 1) * 86400) + Time('S')
          LoginTime.Node = TimeIn.Node
          Call RecentEvents UserName.Node || ' Started a PPP Connection on Node ' || Node
          LastAck = TheTime
       End
       When Control = 2 Then Call LogoutnBill
       Otherwise LastAck = ((Today - 1) * 86400) + Time('S')       /* Ack */
      End
   End
   TheTime = ((Date('D') - 1) * 86400) + Time('S')
   If TheTime > TimeControl Then Do                        /* 20 Sec Timer up */
      If RunningNodes \= '' Then Do
         Do b = 1 To Words(RunningNodes)
            Node = Word(RunningNodes,b)
            Elapsed = TheTime - LoginTime.Node
            Call ElapsednCost ConvTime(TheTime - TimeIn.Node) || '  [34m  [37m' ||  Left('$' || Trunc(((Elapsed / 3600) * PeriodRate.Period) + Cost.Node,2),8)
         End
      End
      If TheTime > TimeControl2 Then Do
         Call CharOut, '[25;70H[1;37;46m' || Left(Time('C'),7)
         If Date('D') > Today Then Do
            Call UpdateDate
            Call RecentEvents 'Totals for Today => Money Earnt: $' || Trunc(MoneyEarnt,2) || ', Internet Users: ' || InternetUsers
            If Word(Date(),1) = '1' Then Do
               Call RecentEvents 'New Month, Accounting due to run today'
               BillToday = 1
            End
            MoneyEarnt = 0
            InternetUsers = 0
            Call UpdateInternetUsers2Day
            Call UpdateMoneyEarnt
            Today = Date('D')
         End
         If (RunningNodes \= '' & TheTime - LastAck > 70) Then Do /* BBS No Response within 1.16 minutes, assume crashed */
            Call RecentEvents 'BBS appears to have crashed, force billing'
            Do b = 1 To Words(RunningNodes)
               Node = Word(RunningNodes,b)
               Call LogoutnBill
            End
            RunningNodes = ''
            Call RecentEvents 'Waiting for client or event'
            Iterate
         End
         If (BillToday = 1 & TheTime > AccountingTime) Then Do
            If RunningNodes \= '' Then Call RecentEvents 'Accounting Suspended; User online'
            Else Do
               Call RecentEvents 'Running Monthly Accounting'
               Call RxFuncAdd 'SysFileTree', 'RexxUtil', 'SysFileTree'
               Call SysFileTree AccountingDirectory || '*.*', 'File.', 'F'
               Call ReportsOut
               Call RecentEvents 'Monthly Accounting Completed => Accounts Processed: ' || Accounts - 1
               Drop BillToday
            End
         End
         If TheTime > PeriodEnd Then Call NewEvent      /* New Charge Bracket */
         TimeControl2 = TheTime + 60
      End
      TimeControl = TheTime + SleepTime
   End
   Call Delay '2'
End
Call FinishUp


/*------------------------------| Functions |---------------------------------*/
SetupScreen:
    Say '[44m[2J[1;37;44m      PPP Internet/Accounting Server v' || Version || ' (C) Copyright by [36mRob Stephens       '
    Call CharOut, '[34m[33mNd[34m[33mUser[34m[33mIP Address[34m[33mLogon[34m[33mElapsed[34m[33mCost[34m[37m'
    Do c = 1 To Nodes
       Say ' ' || Right(c,2,'0') || Copies(' ',65) || '[34m[K[37m'
    End
    Call CharOut, '[34m[33mRecent Activity[34m[37;45m ' || Left(Date('N'),11) || ' [34;44m'
    Do 23 - (Nodes + 3)
       Say '[K'
    End
    Call CharOut, '[24;1H[0;34;46m Users Today:           Charge Event:                 Charging Rate:            '
    Call CharOut, '[25;1H Money Today:           Event Period:                 The Time is  : [1;37m' || Left(Time('C'),7) || '[K[0m'
    Call UpdateInternetUsers2Day
    Call UpdateMoneyEarnt
    Call UpdateEventInformation
Return
UpdateInternetUsers2Day:
    Call CharOut, '[24;15H[1;37;46m' || Left(InternetUsers,3)
Return
UpdateMoneyEarnt:
    Call CharOut, '[25;15H[1;37;46m$' || Left(Trunc(MoneyEarnt,2),7)
Return
UpdateDate:
    Call CharOut, '[' || Nodes + 3 || ';34H[37;45m' Left(Date('N'),11)
Return
UpdateEventInformation:
    Call CharOut, '[24;39H[1;37;46m' || Left(Period,3)
    Call CharOut, '[25;39H[1;37;46m' || PeriodReal.Period
    Call CharOut, '[24;70H[1;37;46m$' || Left(PeriodRate.Period || '/hr',8)
Return
UpdateNode:
    Parse Arg Data
    Call CharOut, '[' || Node + 2 || ';5H[1;32;44m ' || Data || '[44m    00:00:00  [34m  [37m$0.00'
Return
ElapsednCost:
    Parse Arg Data
    Call CharOut, '[' || Node + 2 || ';58H[1;32;44m ' || Data
Return
RecentEvents:
    Parse Arg Data
    Call ScrollUp 1,,26,ScrollLine,,23
    Say '[23;1H[1;32;44m ' || Time() || ' [37m' || Data
    Call LineOut LogFile, Date('E') || '  ' || Time() || '   ' || Data
Return
SetupPIPE:
    Do b = 1 To 10
       PipeHandle = NmPipe_Create(Pipe,'M','M','N',48,48)
       If PipeHandle >= 0 Then Leave
       Else Do
          Call NmPipe_Close Pipe
          Call RecentEvents 'Problem creating Pipe [' || Pipe || ']. Attempt #' || b
          Call Delay '2'
          If b = 10 Then Do
             Call RecentEvents 'Error! Could not create pipe [' || Pipe || ']'
             Call RecentEvents 'Exiting'
             Call FinishUp
          End
       End
    End
Return
NewEvent:
    Do b = 1 To Words(RunningNodes)
       Node = Word(RunningNodes,b)
       Elapsed = PeriodEnd - LoginTime.Node
       Detail.Node = Detail.Node || Elapsed || '@' || PeriodRate.Period || ' '
       Cost.Node = Cost.Node + (((PeriodEnd - LoginTime.Node) / 3600) * PeriodRate.Period)
       LoginTime.Node = PeriodEnd
    End
    If Period = a Then Do
       Call ReadCost
       Call RecentEvents 'Re-Loaded Costing File'
    End
    Else Period = Period + 1
    PeriodEnd = PeriodEnd.Period
    Call RecentEvents 'Started Event ' || Period
    Call UpdateEventInformation
Return
ReadCost:               /* Read in prices/period times into respective arrays */
	a = 0
    Do While Lines(CostFile) = 1
	   Data = Strip(LineIn(CostFile),'L')
       If Left(Data,1) = ';' Then Iterate
	   If Data = '' Then Iterate
	   a = a + 1
	   Parse Var Data H1 ':' M1 ':' S1 ' - ' H2 ':' M2 ':' S2 '$' C1
       PeriodReal.a = H1 || ':' || M1 || ' - ' || H2 || ':' || M2
       PeriodStart.a = ((Today - 1) * 86400) + (H1 * 3600) + (M1 * 60) + S1
       PeriodEnd.a = ((Today - 1) * 86400) + (H2 * 3600) + (M2 * 60) + S2
	   PeriodRate.a = C1
	End
    Period = 1
    TheTime = ((Today - 1) * 86400) + Time('S')
    Do 50
       If TheTime >= PeriodStart.Period & TheTime <= PeriodEnd.Period Then Leave
       Period = Period + 1
    End
    PeriodEnd = PeriodEnd.Period
    Call Stream CostFile,'c','Close'
Return
ConvTime: Procedure                          /* Convert Secs to Hrs:Mins:Secs */
	Parse Arg Tmp1
	   Tmp2 = Right(Tmp1 % 3600,2,'0')
	   Tmp3 = Tmp1 - (Tmp2 * 3600)
	   Tmp4 = Right(Tmp3 % 60,2,'0')
	   Tmp5 = Right(Tmp3 - (tmp4 * 60),2,'0')
	   Tmp6 = Tmp2 || ':' || Tmp4 || ':' || Tmp5
Return Tmp6
ReportsOut:
    BeginMonth = Strip(Left(Date('U'),2),'L','0')
    If BeginMonth = 1 Then BeginMonth2 = 12
    Else BeginMonth2 = BeginMonth - 1
    HeaderCnt = 0
    Do While Lines(AccountHeader) = 1
       HeaderCnt = HeaderCnt + 1
       AccountHeader.HeaderCnt = LineIn(AccountHeader)
    End
    Call Stream AccountHeader,'c','Close'
    FooterCnt = 0
    Do While Lines(AccountFooter) = 1
       FooterCnt = FooterCnt + 1
       AccountFooter.FooterCnt = LineIn(AccountFooter)
    End
    Call Stream AccountHeader,'c','Close'
    Do Accounts = 1 To File.0
       File.Accounts = SubStr(File.Accounts,38)
       TempUserName = SubStr(File.Accounts,LastPos('\',File.Accounts) + 1)
       OutUserFile = BillOutDirectory || TempUserName || ' ' || BeginMonth || '.96'
       If Stream(OutUserFile,'c','query exists') \= '' Then Return
       Do c = 1 To HeaderCnt
          Call LineOut OutUserFile, AccountHeader.c
       End
       Call LineOut OutUserFile, ''
       Call LineOut OutUserFile, Centre('Internet Access usage for ' || TempUserName,80)
       Call LineOut OutUserFile, Centre('Period Beginning 01/' || BeginMonth2 || '/96 to ' || Date('E'),80)
       Call LineOut OutUserFile, ''
       Call LineOut OutUserFile, 'Date of    Login      LogOff     Node  hh:mm:ss  hh:mm:ss                 Total'
       Call LineOut OutUserFile, 'Call       Time       Time       Num   Online    Rate/Hour Details        Cost'
       Call LineOut OutUserFile, '-------------------------------------------------------------------------------'
       TempCost = 0
       Do While Lines(File.Accounts) = 1
          Temp = LineIn(File.Accounts)
          Pos = LastPos('$',Temp)
          If Pos > 70 Then TempCost = TempCost + SubStr(Temp,Pos + 1)
          Call LineOut OutUserFile, Temp
       End
       Call LineOut OutUserFile, '-------------------------------------------------------------------------------'
       Call LineOut OutUserFile, '                                                    Total of this bill $' || Right(Trunc(TempCost,2),7)
       Call LineOut OutUserFile, 'Total amount payable: $' || Trunc(TempCost,2)
       Call LineOut OutUserFile, 'Payment due by: 15/' || BeginMonth || '/96'
       Call LineOut OutUserFile, ''
       Do c = 1 To FooterCnt
          Call LineOut OutUserFile, AccountFooter.c
       End
       Call Stream OutUserFile,'c','close'
       Call Stream File.Accounts,'c','close'
       Address Cmd '@Del "' || File.Accounts || '" >nul'
    End
    Do c = 1 To HeaderCnt                                      /* Free Memory */
       Drop AccountHeader.c
    End
    Do c = 1 To FooterCnt                                      /* Free Memory */
       Drop AccountFooter.c
    End
Return
LogoutnBill:
    RunningNodes = DelWord(RunningNodes,WordPos(Node,RunningNodes),1)
    Call CharOut, '[' || Node + 2 || ';6H[44m' || Copies(' ',63) || '[34m[K'
    Elapsed = (((Today - 1) * 86400) + Time('S')) - LoginTime.Node
    InternetUsers = InternetUsers + 1
    Call UpdateInternetUsers2Day
    If Elapsed > MinimumTimeForAccounting Then Do
       Cost.Node = Cost.Node + ((Elapsed / 3600) * PeriodRate.Period)
       Detail.Node = Detail.Node || Elapsed || '@' || PeriodRate.Period
       MoneyEarnt = MoneyEarnt + Cost.Node
       Call UpdateMoneyEarnt
    End
    Else Do
       Call RecentEvents UserName.Node || ' under billing low watermark, not charging'
       Return
    End
    BillTotal = 0
    AccountFile = AccountingDirectory || UserName.Node
    LogOutTime = Time('S')
    Elapsed = (((Today - 1) * 86400) + LogOutTime) - TimeIn.Node
    c = Words(Detail.Node)
    Parse Value Word(Detail.Node,1) With Time '@' Rate .
    BillTotal = ((Time / 3600) * Rate)
    Temp = DateIn.Node || '   ' || LoginRealTime.Node || '   ' || ConvTime(LogOutTime) || '   ' || Left(Node,2) || '    ' || ConvTime(Elapsed) || '  ' || Left(ConvTime(Time) || ' @ $' || Rate,20) || '  '
    If c < 2 Then Temp = Temp || Right('$' || Trunc(BillTotal,2),8)
    Call LineOut AccountFile, Temp
    Do b = 2 To c
       Parse Value Word(Detail.Node,b) With Time '@' Rate .
       BillTotal = BillTotal + ((Time / 3600) * Rate)
       If b = c Then Call LineOut AccountFile, Copies(' ',49) || Left(ConvTime(Time) || ' @ $' || Rate,20) || '  ' || Right('$' || Trunc(BillTotal,2),8)
       Else Call LineOut AccountFile, Copies(' ',49) || Left(ConvTime(Time) || ' @ $' || Rate,20)
    End
    Call RecentEvents UserName.Node || ' Logout Node ' || Node || ' => Elapsed ' || ConvTime(Elapsed) || ', Cost $' || Trunc(BillTotal,2)
    Call Stream AccountFile,'c','Close'
Return
OkTune:                                        /* Play a Tune when PPP Starts */
   Call Beep 900, 200
   Call Beep 1000, 200
   Call Beep 1100, 200
Return
FinishUp:                                                 /* Cleanup and Exit */
    Call NmPipe_Close Pipe
    Call Stream LogFile,'c','Close'
    Call SysCurState 'ON'
    Call CharOut, '[0m'
    Say;Say;Say 'Exiting ...'
    Exit
Return
